/*
  barbarin.c - Patch Barbarian (v1.3) to fix WATER element message.

  Jason Hood, 31 December, 2013.

  4 April, 2015: support the GoG version.

  Build (VC6):
	cl /nologo /W3 /O2 /MD barbarin.c user32.lib /link /opt:nowin98
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <string.h>

int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
		    LPSTR lpCmdLine, int nCmdShow )
{
  HANDLE barbarin;
  char	 buf[8];
  DWORD  n;
  LPCSTR msg;

  barbarin = CreateFile( "barbarin.ddp", GENERIC_READ | GENERIC_WRITE, 0,
			 NULL, OPEN_EXISTING, 0, NULL );
  if (barbarin == INVALID_HANDLE_VALUE)
  {
    msg = "Unable to open BARBARIN.DDP.";
    goto out;
  }
  SetFilePointer( barbarin, 0x83ec5, NULL, FILE_BEGIN );
  ReadFile( barbarin, buf, 5, &n, NULL );
  if (n != 5)
  {
    msg = "Unable to read from BARBARIN.DDP.";
    goto out;
  }
  if (memcmp( buf, "ABLE ", 5 ) == 0)
  {
    SetFilePointer( barbarin, 0x84ec5, NULL, FILE_BEGIN );
    ReadFile( barbarin, buf, 5, &n, NULL );
    if (n != 5)
    {
      msg = "Unable to read from BARBARIN.DDP.";
      goto out;
    }
  }
  if (memcmp( buf, "EARTH", 5 ) == 0)
  {
    memcpy( buf, "WATER", 5 );
    SetFilePointer( barbarin, -5, NULL, FILE_CURRENT );
    WriteFile( barbarin, buf, 5, &n, NULL );
    if (n != 5)
    {
      msg = "Unable to write to BARBARIN.DDP.";
      goto out;
    }
    msg = "Patch applied.";
  }
  else if (memcmp( buf, "WATER", 5 ) == 0)
  {
    msg = "Patch already applied.";
  }
  else
  {
    msg = "Unsupported version of BARBARIN.DDP.";
  }

out:
  MessageBox( NULL, msg, "Barbarian Patch", MB_ICONINFORMATION );

  return 0;
}
