/*
  mm.c - Patch International Man of Mystery to display the table title.

  Jason Hood, 10 & 11 March, 2016.

  "International Man of Mystery, V1.0" is too long for the dotpanel, so
  just use "Man of Mystery, V1.0".

  Build (VC):
	cl /nologo /W3 /O2 /GF mm.c
  For an even smaller file, I removed the "Rich" signature, reducing the header.
  VS2010+ users will want to add "/link /fixed" to remove the relocations (it's
  ignored as a pragma, unfortunately).
*/

#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#pragma comment(lib, "kernel32")
#pragma comment(lib, "user32")
#pragma comment(linker, "/entry:Patch /subsystem:windows")
#if _MSC_VER < 1300
#pragma comment(linker, "/filealign:512")
#endif


const DWORD addr[2] = { 0x1550E, 0x1610E };


int Patch( void )
{
  HANDLE mm;
  DWORD  rel;
  DWORD  n;
  LPCSTR msg;
  int	 i;

  mm = CreateFile( "mm.ddp", GENERIC_READ | GENERIC_WRITE, 0,
		   NULL, OPEN_EXISTING, 0, NULL );
  if (mm == INVALID_HANDLE_VALUE)
  {
    msg = "Unable to open MM.DDP.";
    goto out;
  }
  for (i = 0; i < 2; ++i)
  {
    SetFilePointer( mm, addr[i], NULL, FILE_BEGIN );
    ReadFile( mm, &rel, 4, &n, NULL );
    if (n != 4)
    {
      msg = "Unable to read from MM.DDP.";
      goto out;
    }
    if (rel == 0xFFFF59CE)
      break;
    else if (rel == 0x0005303E)
    {
      msg = "Patch already applied.";
      goto out;
    }
  }
  if (i == 2)
  {
    msg = "Unsupported version of MM.DDP.";
    goto out;
  }
  SetFilePointer( mm, 0x5303E, NULL, FILE_CURRENT );
  WriteFile( mm, "\x52"                 // push edx
		 "\x83\x02\x0E"         // add  dword[edx],14.
		 "\x83\x6A\x08\x0E"     // sub  dword[edx+8],14.
		 "\xE8\x83\x29\xFA\xFF" // call 40BAE0
		 "\x5A"                 // pop  edx
		 "\x83\x2A\x0E"         // sub  dword[edx],14.
		 "\x83\x42\x08\x0E"     // add  dword[edx+8],14.
		 "\xC3"                 // ret
		 , 0x16, &n, NULL );
  if (n != 0x16)
  {
    msg = "Unable to write to MM.DDP.";
    goto out;
  }
  rel = 0x0005303E;
  SetFilePointer( mm, addr[i], NULL, FILE_BEGIN );
  WriteFile( mm, &rel, 4, &n, NULL );
  if (n != 4)
  {
    msg = "Unable to write to MM.DDP.";
    goto out;
  }
  msg = "Patch applied.";

out:
  MessageBox( NULL, msg, "International Man of Mystery Patch", MB_ICONINFORMATION );

  return 0;
}
